
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

int did_init = 0;

/* return a (pseudo)random integer in the range [0,n-1] */
int randlimit(int n) {
  if(!did_init) {
    did_init = 1;
    srandom(time(NULL));
  }
  return random() % n;
}

void print_array(int len, int * arr) {
  int i;
  printf("\n[");
  for(i=0; i < len; ++i)
    printf(" %d ", arr[i]);
  printf("]\n");
}

/* This is a fine place for your two functions. */

int main(int argc, char**argv) {
  if(argc != 2) {
    fprintf(stderr,"usage: %s n\n",argv[0]);
    return 1;
  }
  int i = atoi(argv[1]);
  if(i <= 0) {
    fprintf(stderr,"argument should be a positive integer\n");
    return 1;
  }
  int * arr = make_array(i);
  permute_array(i,arr);
  print_array(i,arr);
  free(arr);
  return 0;
}
